=== debian/changelog ===
nco (4.7.0-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 15 Nov 2017 07:25:07 +0100

nco (4.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.1, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 09 Nov 2017 19:07:59 +0100
