## nco 4.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,10 +52,12 @@
 #general C/C++ build flags
 #/////////////////////////////////////////////////////////////////////////////////////
 
-set(CMAKE_BUILD_TYPE Debug)
-set(BUILD_STATIC_LIBS ON)
-set(BUILD_SHARED_LIBS OFF)
-add_definitions(-DENABLE_STATIC)
+set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build.")
+set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build static libs.")
+
+if (NOT BUILD_SHARED_LIBS)
+  add_definitions(-DENABLE_STATIC)
+endif()
 
 #//////////////////////////
 #detect minimum dependencies using
@@ -104,6 +106,7 @@
 #netCDF
 #Check for several functions in the netCDF library; define C macro accordingly
 #CMAKE_REQUIRED_LIBRARIES needs NETCDF_LIBRARY
+#check for header file netcdf_mem.h existence
 #/////////////////////////////////////////////////////////////////////////////////////
 
 set(CMAKE_REQUIRED_LIBRARIES ${NETCDF_LIBRARY})
@@ -119,19 +122,27 @@
   add_definitions(-DHAVE_NC_INQ_FORMAT)
 endif()
 
+find_path(netcdf_mem_h netcdf_mem.h)
+if (netcdf_mem_h)
+  message("-- Found netcdf_mem.h in: " ${netcdf_mem_h})
+  add_definitions(-DHAVE_NETCDF_MEM_H)
+else()
+  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h not found")
+endif()
+
 #/////////////////////////////////////////////////////////////////////////////////////
 #HDF5
 #/////////////////////////////////////////////////////////////////////////////////////
 
 
-find_library(HDF5_LIBRARY NAMES hdf5 ${find_opt})
+find_library(HDF5_LIBRARY NAMES hdf5 PATHS "/usr/lib/x86_64-linux-gnu/hdf5/serial")
 if(NOT HDF5_LIBRARY)
   message(FATAL_ERROR "${color_red}hdf5 library not found${color_reset}")
 else()
   message("-- Found hdf5 library at: " ${HDF5_LIBRARY})
 endif()
 
-find_library(HDF5_HL_LIBRARY NAMES hdf5_hl ${find_opt})
+find_library(HDF5_HL_LIBRARY NAMES hdf5_hl PATHS "/usr/lib/x86_64-linux-gnu/hdf5/serial")
 if(NOT HDF5_HL_LIBRARY)
   message(FATAL_ERROR "${color_red}hdf5 high level library not found${color_reset}")
 else()
@@ -238,22 +249,27 @@
 #compile as C++/static CRT on Visual Studio and as C99 on UNIX
 #//////////////////////////
 
+set(NCO_MSVC_USE_MT yes CACHE BOOL "Use MT flags when compiling in MSVC")
+
 if (MSVC)
   add_definitions( "/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_DEPRECATE" )
-  message("-- Building with static runtime library")
-  set(CMAKE_CXX_FLAGS_DEBUG "/D_DEBUG /MTd /Zi /Ob0 /Od /RTC1")
-  set(CMAKE_CXX_FLAGS_MINSIZEREL     "/MT /O1 /Ob1 /D NDEBUG")
-  set(CMAKE_CXX_FLAGS_RELEASE        "/MT /O2 /Ob2 /D NDEBUG")
-  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/MT /Zi /O2 /Ob1 /D NDEBUG")
-  
+
+  if (NCO_MSVC_USE_MT)
+     foreach(CompilerFlag CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
+                          CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
+                          CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
+                          CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
+       string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
+     endforeach()
+  endif()
+
   #//////////////////////////
   #compile as C++ Code (/TP)
   #//////////////////////////
-
-  set(CMAKE_C_FLAGS_DEBUG "/TP /D_DEBUG /MTd /Zi /Ob0 /Od /RTC1")
-  set(CMAKE_C_FLAGS_MINSIZEREL     "/TP /MT /O1 /Ob1 /D NDEBUG")
-  set(CMAKE_C_FLAGS_RELEASE        "/TP /MT /O2 /Ob2 /D NDEBUG")
-  set(CMAKE_C_FLAGS_RELWITHDEBINFO "/TP /MT /Zi /O2 /Ob1 /D NDEBUG")
+  foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
+                       CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
+    set(${CompilerFlag} "/TP ${${CompilerFlag}}")
+  endforeach()
 
   #//////////////////////////
   #visual studio defines math symbols in math.h, avoid duplicate definition
@@ -324,26 +340,3 @@
 set(LIB_DEP ${LIB_DEP} ${UDUNITS2_LIBRARY} ${EXPAT_LIBRARY}) 
 endif()
 
-#//////////////////////////
-# system specific libraries needed to link (assume existing)
-#//////////////////////////
-
-if(APPLE)
-  set(LIB_DEP ${LIB_DEP} resolv)
-endif()
-
-if(MSVC)
-  set(LIB_DEP ${LIB_DEP} ws2_32.lib winmm.lib wldap32.lib)
-endif()
-
-if(UNIX)
-  set(LIB_DEP ${LIB_DEP} m)
-endif()
-
-#//////////////////////////
-#nco lib sources 
-#//////////////////////////
-
-set(nco_SOURCES ${nco_SOURCES} src/nco/libnco.h)
-set(nco_SOURCES ${nco_SOURCES} src/nco/nco_att_utl.c src/nco/nco_att_utl.h)
-set(nco_SOURCES ${nco_SOURCES} src/nco/nco_aux.c src/nco/nco_aux.h)
