=== debian/changelog ===
nco (4.7.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 07 Jan 2018 11:52:47 +0100

nco (4.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.2, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 21 Dec 2017 18:29:08 +0100
