=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                libudunits2-dev,
                libdap-dev,
                texinfo
-Standards-Version: 4.1.1
+Standards-Version: 4.1.2
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/nco.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/nco.git -b stretch-backports
 Homepage: http://nco.sourceforge.net/
