## nco 4.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,11 +50,16 @@
 
 #/////////////////////////////////////////////////////////////////////////////////////
 #general C/C++ build flags
-#/////////////////////////////////////////////////////////////////////////////////////
-
-set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build.")
+#on single-configuration generators (Unix Makefiles, NMake Makefiles) use Debug as default
+#on multi-configuration generators (Visual Studio, Xcode) define only 2 types: Debug;Release
+#/////////////////////////////////////////////////////////////////////////////////////
+
+set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
+if(CMAKE_CONFIGURATION_TYPES)
+  set(CMAKE_CONFIGURATION_TYPES "Debug;Release")
+endif()
+
 set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build static libs.")
-
 if (NOT BUILD_SHARED_LIBS)
   add_definitions(-DENABLE_STATIC)
 endif()
@@ -87,11 +92,35 @@
   message("${color_blue}-- Using user defined netCDF location: ${netcdf_root}${color_reset}")
 endif()
 
+#//////////////////////////
+#a user defined -DNETCDF_INCLUDE was specified; check if it really exists :-)
+#//////////////////////////
+
+if(NETCDF_INCLUDE)
+  if(EXISTS "${NETCDF_INCLUDE}/netcdf.h")
+    message("-- Using ${NETCDF_INCLUDE}/netcdf.h")
+  else()
+    message(FATAL_ERROR "${color_red}netcdf.h not found at ${NETCDF_INCLUDE}${color_reset}")
+  endif()
+endif()
+
 find_path(NETCDF_INCLUDE netcdf.h ${find_opt})
 if(NOT NETCDF_INCLUDE)
   message(FATAL_ERROR "${color_red}netcdf.h header file not found${color_reset}")
 else()
   message("-- Found netcdf.h header file at: " ${NETCDF_INCLUDE})
+endif()
+
+#//////////////////////////
+#a user defined -DNETCDF_LIBRARY was specified; check if it really exists :-)
+#//////////////////////////
+
+if(NETCDF_LIBRARY)
+  if(EXISTS "${NETCDF_LIBRARY}")
+    message("-- Using ${NETCDF_LIBRARY}")
+  else()
+    message(FATAL_ERROR "${color_red}Specified ${NETCDF_LIBRARY} does not exist${color_reset}")
+  endif()
 endif()
 
 find_library(NETCDF_LIBRARY NAMES netcdf PATHS ${NETCDF_LIBRARY_PATH} NO_DEFAULT_PATH)
@@ -122,13 +151,24 @@
   add_definitions(-DHAVE_NC_INQ_FORMAT)
 endif()
 
-find_path(netcdf_mem_h netcdf_mem.h)
-if (netcdf_mem_h)
-  message("-- Found netcdf_mem.h in: " ${netcdf_mem_h})
+find_path(path_netcdf_mem_h netcdf_mem.h PATHS ${NETCDF_INCLUDE})
+if (path_netcdf_mem_h)
+  message("-- Found netcdf_mem.h in: " ${path_netcdf_mem_h})
+endif()
+
+check_library_exists(${NETCDF_LIBRARY} nc_open_mem "" has_nc_open_mem)
+if (has_nc_open_mem)
+  message("-- Found nc_open_mem in: " ${NETCDF_LIBRARY})
+endif()
+
+if (has_nc_open_mem AND path_netcdf_mem_h)
   add_definitions(-DHAVE_NETCDF_MEM_H)
-else()
-  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h not found")
-endif()
+  message("-- NetCDF diskless functionaliy enabled")
+else()
+  message("-- NetCDF diskless functionaliy not available, netcdf_mem.h or nc_open_mem not found")
+endif()
+
+
 
 #/////////////////////////////////////////////////////////////////////////////////////
 #HDF5
@@ -249,26 +289,31 @@
 #compile as C++/static CRT on Visual Studio and as C99 on UNIX
 #//////////////////////////
 
-set(NCO_MSVC_USE_MT yes CACHE BOOL "Use MT flags when compiling in MSVC")
-
 if (MSVC)
-  add_definitions( "/D_CRT_SECURE_NO_WARNINGS /D_CRT_NONSTDC_NO_DEPRECATE" )
-
-  if (NCO_MSVC_USE_MT)
-     foreach(CompilerFlag CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
-                          CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
-                          CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
-                          CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
-       string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
-     endforeach()
+  set(MSVC_USE_STATIC_CRT ON CACHE BOOL "Use /MT flag (static CRT) when compiling in MSVC")
+  if (MSVC_USE_STATIC_CRT)
+    message("-- Using static CRT ${MSVC_USE_STATIC_CRT}")
+    foreach(flag_var CMAKE_CXX_FLAGS_DEBUG 
+      CMAKE_CXX_FLAGS_RELEASE
+      CMAKE_CXX_FLAGS_MINSIZEREL 
+      CMAKE_CXX_FLAGS_RELWITHDEBINFO
+      CMAKE_C_FLAGS_DEBUG 
+      CMAKE_C_FLAGS_RELEASE
+      CMAKE_C_FLAGS_MINSIZEREL 
+      CMAKE_C_FLAGS_RELWITHDEBINFO)
+    string(REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
+    endforeach()
   endif()
 
   #//////////////////////////
   #compile as C++ Code (/TP)
   #//////////////////////////
-  foreach(CompilerFlag CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
-                       CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
-    set(${CompilerFlag} "/TP ${${CompilerFlag}}")
+  
+  foreach(flag_var CMAKE_C_FLAGS_DEBUG 
+    CMAKE_C_FLAGS_RELEASE
+    CMAKE_C_FLAGS_MINSIZEREL 
+    CMAKE_C_FLAGS_RELWITHDEBINFO)
+  set(${flag_var} "/TP ${${flag_var}}")
   endforeach()
 
   #//////////////////////////
@@ -279,64 +324,17 @@
 
 else (MSVC)
 
-#//////////////////////////
-#compile as C99
-#//////////////////////////
-
-if(CMAKE_VERSION VERSION_LESS "3.1")
-  if(CMAKE_COMPILER_IS_GNUCC)
-    set(CMAKE_C_FLAGS "--std=gnu99 ${CMAKE_C_FLAGS}")
-  endif()
-else()
-  set(CMAKE_C_STANDARD 99)
-endif()
-
-#//////////////////////////
-# other gcc flags
-#//////////////////////////
-
-if(CMAKE_COMPILER_IS_GNUCC)
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9)
-   set(CMAKE_C_FLAGS "-D_BSD_SOURCE -D_POSIX_SOURCE ${CMAKE_C_FLAGS}")
-  else()
-   set(CMAKE_C_FLAGS "-D_DEFAULT_SOURCE ${CMAKE_C_FLAGS}")
-  endif()
-endif()
-
-endif(MSVC)
-
-
-#//////////////////////////
-#link with libraries
-#LIB_DEP contains a cascade definition of all the libraries needed to link
-#//////////////////////////
-
-set(LIB_DEP ${LIB_DEP})
-set(LIB_DEP ${LIB_DEP} ${NETCDF_LIBRARY})
-set(LIB_DEP ${LIB_DEP} ${HDF5_HL_LIBRARY})
-set(LIB_DEP ${LIB_DEP} ${HDF5_LIBRARY})
-set(LIB_DEP ${LIB_DEP} ${CURL_LIBRARY})
-if (NEED_ZLIB)
-  set(LIB_DEP ${LIB_DEP} ${ZLIB_LIBRARY})
-endif()
-if (NEED_SZIP)
-  set(LIB_DEP ${LIB_DEP} ${SZIP_LIBRARY})
-endif()
-
-#//////////////////////////
-#add definitions based on libraries found
-#//////////////////////////
-
-if(NETCDF_INCLUDE AND NETCDF_LIBRARY)
-add_definitions(-DHAVE_NETCDF4_H)
-add_definitions(-DENABLE_NETCDF4)
-include_directories(${NETCDF_INCLUDE})
-endif()
-
-if(UDUNITS2_INCLUDE AND UDUNITS2_LIBRARY AND EXPAT_LIBRARY)
-add_definitions(-DENABLE_UDUNITS)  
-add_definitions(-DHAVE_UDUNITS2_H) 
-include_directories(${UDUNITS2_INCLUDE})  
-set(LIB_DEP ${LIB_DEP} ${UDUNITS2_LIBRARY} ${EXPAT_LIBRARY}) 
-endif()
-
+  #//////////////////////////
+  #compile as C99
+  #//////////////////////////
+
+  if(CMAKE_VERSION VERSION_LESS "3.1")
+    if(CMAKE_COMPILER_IS_GNUCC)
+      set(CMAKE_C_FLAGS "--std=gnu99 ${CMAKE_C_FLAGS}")
+    endif()
+  else()
+    set(CMAKE_C_STANDARD 99)
+  endif()
+
+  #//////////////////////////
+  # other gcc flags
