=== debian/changelog ===
nco (4.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright-format URL to use HTTPS.
  * Bump Standards-Version to 4.1.3, no changes.
  * Update copyright years for Charlie Zender.
  * Add lintian overrides for binary-without-manpage.
  * Strip trailing whitespace from changelog file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 25 Jan 2018 20:04:04 +0100
