=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
                texinfo
 Standards-Version: 4.1.3
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/nco.git
-Vcs-Git: https://anonscm.debian.org/git/pkg-grass/nco.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-grass/nco.git -b stretch-backports
 Homepage: http://nco.sourceforge.net/
 
 Package: nco
